package com.qmrz.service.outside.sync;

import com.alibaba.fastjson.JSONObject;
import com.qmrz.api.common.SpringContextUtil;
import com.qmrz.api.common.SysInfo;
import com.qmrz.service.outside.v2.BaseSyncV2;
import com.qmrz.service.outside.v2.SyncDTO;
import com.qmrz.utils.DateTimeUtil;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 同步 ${table_comment}（${table_name}）
 */
public class ${table_name2}Sync extends BaseSyncV2 {
    @Override
    protected Map<String, String> getSyncFieldMapping() {
        Map<String, String> fieldMapping = new HashMap<>();
        <#list columnList as item>
            fieldMapping.put("${item.column_name}","${item.column_name}");
        </#list>
        return fieldMapping;
    }

    /**
     * 批量插入mapid
     *
     * @return
     */
    @Override
    protected String insertMapID() {
        return "${table_name2}Mapper.sync_batch_insert";
    }

    /**
     * 批量更新mapid
     *
     * @return
     */
    @Override
    protected String updateMapID() {
        return "${table_name2}Mapper.sync_batch_update";
    }

    /**
     * 批量删除mapid
     *
     * @return
     */
    @Override
    protected String deleteMapID() {
        return "${table_name2}Mapper.sync_batch_delete";
    }

    /**
     * 最大maxid，一个同步循环只从DB获取一次
     *
     * @return
     */
    @Override
    protected String maxidMapID() {
        return "${table_name2}Mapper.sync_batch_select_maxid";
    }

    /**
     * 查询DB数据，用与api数据比对后的 增、改
     *
     * @return
     */
    @Override
    protected String selectDBMapID() {
        return "${table_name2}Mapper.sync_batch_select";
    }

    /**
     * 查询DB数据，用与api数据比对后的 删除
     *
     * @return
     */
    @Override
    protected String selectDBPageMapID() {
        return "${table_name2}Mapper.sync_batch_select_page";
    }

    /**
     * 表名
     *
     * @return
     */
    @Override
    protected String getTableName() {
        return "${table_name}";
    }

    @Override
    protected String getPrimaryFieldName() {
        return "${primaryKeyName}";
    }

    /**
     * api接口页码
     *
     * @return
     */
    @Override
    protected int getApiPageSize() {
        return 1000; //不超过5000，单次api查询最多返回5000条
    }

    /**
     * 数据同步 api url
     *
     * @return
     */
    @Override
    protected String getSyncUrl(SyncDTO syncDTO) {
        SysInfo info = SpringContextUtil.getBean(SysInfo.class);
        StringBuilder param = new StringBuilder()
                .append("epid=" + info.getEpid())
                .append("&xzqhdm=" + info.getXzqhdm())
                .append("&tableName=" + this.getTableName());
        syncDTO.setSyncapiparam(param.toString());
        return this.getSyncDTO().getSyncapiurl();
    }

    @Override
    public boolean getOpenLimitAPI(){
        return true;
    }

    /**
     * 查询时默认参数
     *
     * @return
     */
    @Override
    protected Map<String, Object> getDefaultSelectParamDB(SyncDTO syncDTO) {
        return new HashMap<>();
    }

    @Override
    protected void insertAddField(Map<String, String> insertMap, JSONObject jsonObjectAPI) {
        //insertMap.put("id", Fn.getUUID());
        jsonObjectAPI.put("syscreatetime", DateTimeUtil.currentStr());
        jsonObjectAPI.put("sysupdatetime", DateTimeUtil.currentStr());
    }

    @Override
    protected void updateAddField(Map<String, String> updateMap, JSONObject jsonObjectAPI) {
        jsonObjectAPI.put("sysupdatetime", DateTimeUtil.currentStr());
    }

    @Override
    protected void getBeforeCheckRowAPI(Map<String, String> updateMap, JSONObject jsonObjectAPI) {

    }

    @Override
    protected void getResetRowIDAPI(Map<String, Object> rowAPI, JSONObject jsonObjectAPI, SyncDTO syncDTO) {
    }

    @Override
    protected List<String> apiReturnFieldByDelete() {
        return new ArrayList<>();
    }

    /**
     * 是否开启增量模式同步
     *
     * @return
     */
    @Override
    protected boolean getIsOpenMaxIDModel() {
        return false;
    }

    /**
     * 默认maxid，若自增为数字时，可设为0。若字符串时，可以设置为空字符串
     *
     * @return
     */
    @Override
    protected String getDefaultMaxID() {
        return "0";
    }

    @Override
    protected String setMaxID(String maxID) {
        return maxID;
    }

    /**
     * （开启子集同步时使用）
     */
    @Override
    protected void syncSubInsertAndUpdate() {
    }

    /**
     * （开启子集同步时使用）
     *
     * @param parentIDListDB 同步删除的数据范围(相对子集的父id集合)
     */
    @Override
    protected void syncSubDelete(List<String> parentIDListDB) {

    }
}
